import os
import unittest
import yaml
import mock


from hooks.hooks import emit_router_config

TEMPLATE_DIR = "../../templates"
ROUTER_CONFIG_FILE = "/var/lib/cloudfoundry/config/gorouter.yml"


class TestConfigHelper(unittest.TestCase):

    @mock.patch('hooks.hooks.host.write_file')
    def test_emit_router_config(self, write_file):
        emit_router_config({
            'nats_address': 'addy',
            'nats_port': 123,
            'nats_password': 'password',
            'nats_user': 'user'})

        args, kw = write_file.call_args_list[0]
        self.assertEqual(
            yaml.safe_load(args[1])['nats'][0],
            {'host': 'addy',
             'port': 123,
             'pass': 'password',
             'user': 'user'})
        self.assertEqual(kw['owner'], 'vcap')
        self.assertEqual(kw['group'], 'vcap')


if __name__ == '__main__':
    unittest.main()
